/* This file is part of the KDE project
   Copyright (C) 2002 Simon Hausmann <hausmann@kde.org>

   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.

   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public License
   along with this library; see the file COPYING.LIB.  If not, write to
   the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.
*/
#ifndef WINDOWFORWARDER_H
#define WINDOWFORWARDER_H

#include "messageforwarder.h"

namespace IRC
{

class Frontend;
class Window;

class WindowForwarder : public MessageForwarder
{
    Q_OBJECT
public:
    WindowForwarder( Frontend *parent, const char *name = 0 );

    void registerWindow( Window *window );

public slots:
    void handlePrivmsgMessage( const IRC::PrivmsgMessage &msg );
    void handleNoticeMessage( const IRC::NoticeMessage &msg );
    void handleTopicMessage( const IRC::TopicMessage &msg );
    void handleJoinMessage( const IRC::JoinMessage &msg );
    void handlePartMessage( const IRC::PartMessage &msg );
    void handleNumericMessage( const IRC::Message &msg );

protected:
    // I wish I could use using
    void forwardMessage( const IRC::Message &msg ) { MessageForwarder::forwardMessage( msg ); }
    virtual void forwardMessage( const QString &key, const IRC::Message &msg );

private:
    Frontend *m_frontend;
};

};
#endif // WINDOWFORWARDER_H
/* vim: et sw=4 ts=4
 */
